/*
 * cgi-query.H
 */
/*
    This file is a CGI Script interface
    Copyright (C) 1994  Allen S. Firstenberg
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _CGIQUERY_H
#define _CGIQUERY_H

#include "standard.H"

/***************************************************************************/

// These are from the utilities
extern "C" {
  void getword(char *word, char *line, char stop);
  char x2c(char *what);
  void unescape_url(char *url);
  void plustospace(char *str);

  char *makeword(char *line, char stop);
  char *fmakeword(FILE *f, char stop, int *len);

}

/***************************************************************************/

// The name and value
class QueryEntry{
public:
  // Constructor/destructor
  QueryEntry( char *n = NULL, char *v = NULL );
  ~QueryEntry();

  // Accessor
  char *name();
  char *val();

  // Assignment
  char *name( char *n );
  char *val( char *v );
  
private:
  char *v_name;
  char *v_val;
};

/***************************************************************************/

class CgiQuery{
public:
  // Constructor/destructor
  CgiQuery( char *method, int max_entries );
  ~CgiQuery();

  // Can this query be done?
  int valid();

  // Return the value associated with the name
  char *lookup( char *name );

protected:
  QueryEntry *entries;
  int num_entries;
};

/***************************************************************************/

/*
 * $Log: cgi-query.H,v $
 * Revision 1.2  1994/07/10  09:16:58  asf
 * Changed the QueryEntry structure to an object.
 *
 * Revision 1.1  1994/07/09  20:08:02  asf
 * Initial revision
 *
 */

#endif
