/*
 * get-query.C
 */
/*
    This file is a CGI Script interface
    Copyright (C) 1994  Allen S. Firstenberg
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "standard.H"
#include "get-query.H"

/***************************************************************************/

GetQuery::GetQuery( int max_entries ):
CgiQuery( "GET", max_entries )
{
  /*
   * Most of this code was lifted directly from cgi-src/query.c
   *
   * Check to make sure we are using the appropriate method and allocate
   * space.  (Done by parent)
   * Read the environment variable into the entries.
   */
  char *cl;
  int x;
  
  if( entries ){
    cl = getenv("QUERY_STRING");
    if(cl == NULL) {
      free( entries );
      entries = NULL;
    } else {
      for(x=0;cl[0] != '\0';x++) {
        num_entries=x;
        entries[x].val( makeword( cl, '&' ) );
        plustospace( entries[x].val() );
        unescape_url( entries[x].val() );
        entries[x].name( makeword( entries[x].val(), '=' ) );
      }
      num_entries++;  // one more entry than the last x
    }
  }
}

//---------------------------------------------------------------------------

GetQuery::~GetQuery()
{
}

/***************************************************************************/

/*
 * $Log: get-query.C,v $
 * Revision 1.2  1994/07/10  09:20:17  asf
 * Adapted the "entries" array so it refers to the object instead of to a
 * normal structure.
 * This includes changing calls of getword() to makeword().
 *
 * Revision 1.1  1994/07/09  20:08:38  asf
 * Initial revision
 *
 */
